package cn.net.cpzslibs.prot.handset;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.Prot10058QueryResult;
import cn.net.cpzslibs.prot.handset.bean.Prot10058SendBean;
import cn.net.cpzslibs.prot.utils.StrUtils;

public class Prot10058QueryNewWine extends ProtBase {
	/**
	 * 是否成功
	 */
	private short iResult;

	private final short iTaskCode10058 = 10058;

	private Gson gson;
	
	public Prot10058QueryNewWine(){
		gson = new Gson();
	}
	private Prot10058QueryResult res;

	
	public Prot10058QueryResult getRes() {
		return res;
	}
	public void setRes(Prot10058QueryResult res) {
		this.res = res;
	}
	
	public void dealQueryNewWine(SocketCreate create,
                                 Prot10058SendBean queryBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(), queryBean);
	}

	private void recProt(Socket socket, DataOutputStream dos,
			DataInputStream dis, Prot10058SendBean queryBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				// 发送登录信息
				debugLog(iTaskCode10058, "开始发送出库信息");
				sendProt(dos, queryBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recLoginDis(dis);
			}
		}
	}

	/**
	 * 读取JSon数据
	 * 
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode10058, "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode10058, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			res = gson.fromJson(jsonData, Prot10058QueryResult.class);
		}
		recCheckCode(dis);
	}

	
	/**
	 * 发送JSon数据到服务器
	 * 
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos,
			Prot10058SendBean queryBean) throws IOException {
		
		String bodyContent = gson.toJson(queryBean).toString();
		
		System.out.println("---bodyContent之后"+bodyContent);
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode10058, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
		
		sendCheckCoded(dos, bodyContent.getBytes("UTF-8"));
	}
}
